﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using ASPItalia.Apps4Windows.WinRT.Model;
using ASPItalia.Apps4Windows.WinRT.Services;

namespace ASPItalia.Apps4Windows.WinRT.Common
{
    public static class SectionsHelper
    {

        private static SynchronizationContext defaultContext;

        static SectionsHelper()
        {
            defaultContext = SynchronizationContext.Current;
        }

        public static async Task<Section> GetAndPrepareSessionAsync(SectionNames name)
        {
            Section section;
            ILoader loader;
            Repository.GetSectionAndLoader(name, out section, out loader);

            var items = await loader.LoadItemsAsync();

            AddItems(section, items);

            return section;
        }

       
        public static void AddItems(Section section, IEnumerable<FeedItem> items)
        {
          int index = 0;
            foreach (FeedItem item in items)
            {
              section.Items.Add(new SectionItem (section, item , index));
              index++;
            }
        }


    }
}
