﻿using ASPItalia.Apps4Windows.WinRT.Model;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.UI;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Media;

namespace ASPItalia.App4Windows8.Xaml.Common.StyleSelectors
{
    public class MainItemStyleSelector : StyleSelector
    {
        protected override Style SelectStyleCore(object item, DependencyObject container)
        {
            var contentItem = item as SectionItem;

            container.SetValue(VariableSizedWrapGrid.ColumnSpanProperty, contentItem.ColumnSpan);
            container.SetValue(VariableSizedWrapGrid.RowSpanProperty, contentItem.RowSpan);
            container.SetValue(ContentControl.VerticalContentAlignmentProperty, VerticalAlignment.Stretch);
            container.SetValue(ContentControl.HorizontalContentAlignmentProperty, HorizontalAlignment.Stretch);

			// ENG: this is applied only when the horizontal template is set
            // ITA: applichiamo questo template solo nel caso di template orizzontale
            if (contentItem != null && contentItem.Section.Layout == LayoutTypeEnum.Alternative)
            {
                if (((SectionItem)item).Index % 3 == 0)
                {
                    container.SetValue(VariableSizedWrapGrid.ColumnSpanProperty, 2);
                    container.SetValue(VariableSizedWrapGrid.RowSpanProperty, 4);
                }
            }

            return base.SelectStyleCore(item, container);
        }
    }
}
