﻿using ASPItalia.Apps4Windows.WinRT.Model;
using ASPItalia.Apps4Windows.WinRT.Services;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Markup;

namespace ASPItalia.App4Windows8.Xaml.Common.TemplateSelector
{
	public class DataPropertyTemplate
	{
		public LayoutTypeEnum Layout { get; set; }
		public DataTemplate DataTemplate { get; set; }
	}

	public class HomeDataTemplateSelector : DataTemplateSelector
	{
		private List<DataPropertyTemplate> dataProperties;
		private Dictionary<LayoutTypeEnum, DataTemplate> templates;

		public List<DataPropertyTemplate> DataTypes
		{
			get
			{
				if (dataProperties == null)
					dataProperties = new List<DataPropertyTemplate>();

				return dataProperties;
			}
		}

		protected override Windows.UI.Xaml.DataTemplate SelectTemplateCore(object ob, Windows.UI.Xaml.DependencyObject container)
		{
			SectionItem item = ob as SectionItem;

			if (templates == null)
			{
				templates = dataProperties.Where(t => t.DataTemplate != null).ToDictionary(t => t.Layout, t => t.DataTemplate);
			}

			DataTemplate dataTemplate;
			if (item != null)
			{
				// solo per l'advertising
				if (item as AdItem != null)
				{
					string template = @"
            <DataTemplate xmlns='http://schemas.microsoft.com/winfx/2006/xaml/presentation'
                    xmlns:pages='using:ASPItalia.Apps4Windows.WinRT.Pages'>
                    <pages:AdButton />
            </DataTemplate>";

					// ENG: load the template at runtime
					// ITA: carichiamo al volo il template
					return XamlReader.Load(template) as DataTemplate;
				}

				templates.TryGetValue(item.Section.Layout, out dataTemplate);
				if (dataTemplate != null)
					return dataTemplate;
			}
			return base.SelectTemplateCore(item, container);
		}

	}
}
