﻿using ASPItalia.Apps4Windows.WinRT.Resources;
using ASPItalia.Apps4Windows.WinRT.Services;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Xml.Linq;
using Windows.ApplicationModel;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Storage;
using Windows.System;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

namespace ASPItalia.Apps4Windows.WinRT.Pages
{
	public sealed partial class AboutPane : UserControl
	{
		public AboutPane()
		{
			this.InitializeComponent();
			OnLoaded();
		}

		async void OnLoaded()
		{
			var file = await Windows.ApplicationModel.Package.Current.InstalledLocation.GetFileAsync("AppxManifest.xml");
			XDocument doc = XDocument.Parse(await FileIO.ReadTextAsync(file));
			XNamespace ns = "http://schemas.microsoft.com/appx/2010/manifest";

			SupportHeader.Text = StringDictionary.Support;
			SupportText.Text = StringDictionary.SupportText;
			SupportButton.Content = StringDictionary.SupportButton;
			InfoHeader.Text = StringDictionary.Info;
			DevelopedBy.Text = StringDictionary.DevelopedBy;
			VersionHeader.Text = StringDictionary.Version;

			Name.Text = doc.Root.Elements(ns + "Properties").First().Element(ns + "DisplayName").Value;
			Publisher.Text = doc.Root.Elements(ns + "Properties").First().Element(ns + "PublisherDisplayName").Value;
			VersionNumber.Text = string.Concat(Package.Current.Id.Version.Major, ".", Package.Current.Id.Version.Minor, ".", 0);
		}

		private async void NavigateToContacts(object sender, RoutedEventArgs e)
		{
			await Launcher.LaunchUriAsync(AppInfo.WebSite);
		}
	}
}
