﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.Storage;
using ASPItalia.Apps4Windows.WinRT.Extensions;

namespace ASPItalia.Apps4Windows.WinRT.Services
{
    class Persister
    {

        public static Task<IStorageFile> GetFileForUri(Uri url, bool createIfNotFound)
        {
            return GetFile(url.ToFileName(), createIfNotFound);
        }

        public static async Task<IStorageFile> GetFile(string fileName, bool createIfNotFound)
        {
            StorageFolder folder = ApplicationData.Current.LocalFolder;

            try
            {
                return await folder.GetFileAsync(fileName);
            }
            catch (FileNotFoundException)
            { }

			// ENG: at this point, the file does not exists
            // ITA: se siamo arrivati fin qui, il file non esiste
            if (createIfNotFound)
                return await folder.CreateFileAsync(fileName);

            return null;
        }
    }
}
