﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ASPItalia.Apps4Windows.WinRT.Services
{
    public class SettingsManager
    {
        public double TextSize
        {
            get { return GetValue("TextSize", 20d); }
            set
            {
                if (SetValue("TextSize", value))
                    OnTextSizeChanged();
            }
        }

        private void OnTextSizeChanged()
        {
            if (TextSizeChanged != null)
                TextSizeChanged(this, EventArgs.Empty);
        }

        public event EventHandler TextSizeChanged;

        private bool SetValue(string key, object value)
        {
            if (Windows.Storage.ApplicationData.Current.RoamingSettings.Values[key] != value)
            {
                Windows.Storage.ApplicationData.Current.RoamingSettings.Values[key] = value;
                return true;
            }
            return false;
        }

        private T GetValue<T>(string key, T defaultValue)
        {
            object v;
            if (Windows.Storage.ApplicationData.Current.RoamingSettings.Values.TryGetValue(key, out v) && v is T)
            {
                return (T)v;
            }

            return defaultValue;
        }
    }
}
